diff -uwr sourceold/scripts/dp88_buildingScripts.h source/scripts/dp88_buildingScripts.h
--- sourceold/scripts/dp88_buildingScripts.h	2011-12-01 12:29:48.027343700 +0800
+++ source/scripts/dp88_buildingScripts.h	2012-05-23 10:33:45.716796800 +0800
@@ -9,8 +9,11 @@
 	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
 	Only the source code to the module(s) containing the licenced code has to be released.
 */
+
 #pragma once
 
+#include "LoopedAnimationController.h"
+
 
 // Define building child types
 #define BUILDING_CHILD_TYPE_GENERIC				0
@@ -99,6 +102,24 @@
 	int parentId;
 };
 
+class dp88_buildingScripts_PT_Script : public ScriptImpClass
+{
+	void Created( GameObject *obj );
+  void Detach ( GameObject *obj );
+	void Custom( GameObject *obj, int type, int param, GameObject *sender );
+	void Timer_Expired ( GameObject* obj, int number );
+	void SetDamageAnimation ( GameObject* obj );
+
+	// ID of the building controller we belong to
+	int parentId;
+	bool dead;
+	bool basePowerState;
+
+protected:
+  LoopedAnimationController* m_pLoopedAnimCtrl;
+public:
+  dp88_buildingScripts_PT_Script() : m_pLoopedAnimCtrl(0) {}
+};
 
 
 
@@ -114,10 +135,10 @@
 class MinorWeakpointScriptClass : public ScriptImpClass
 {
 	void Created( GameObject *obj );
+  void Detach ( GameObject *obj );
 	void Damaged ( GameObject *obj, GameObject *damager, float amount );
 	void Killed( GameObject *obj, GameObject *killer );
 	void Custom( GameObject *obj, int type, int param, GameObject *sender );
-	void Animation_Complete ( GameObject *obj, const char *animation_name );
 
 	// ID of the building controller we belong to
 	int parentId;
@@ -125,11 +146,14 @@
 	// We use this to remember when we are in the destroyed state, so we know
 	// that when we next reach 100% health we need to trigger the repaired event
 	bool isDestroyed;
-	int animstate;
 
 	// Abstract functions
 	virtual void applyEffect ( GameObject *obj, GameObject *parent ) = 0;
 	virtual void reverseEffect ( GameObject *obj, GameObject *parent ) = 0;
+protected:
+  LoopedAnimationController* m_pLoopedAnimCtrl;
+public:
+  MinorWeakpointScriptClass() : m_pLoopedAnimCtrl(0) {}
 };
 
 
@@ -170,6 +194,16 @@
 };
 
 /*------------------------
+Weakpoint - Disable Naval Vehicle Purchase
+--------------------------*/
+
+class dp88_buildingScripts_weakpoint_disableNavalVehiclePurchase : public MinorWeakpointScriptClass
+{
+	void applyEffect ( GameObject *obj, GameObject *parent );
+	void reverseEffect ( GameObject *obj, GameObject *parent );
+};
+
+/*------------------------
 Weakpoint - Disable Base Power
 --------------------------*/
 
@@ -247,6 +281,12 @@
 };
 
 
+class dp88_buildingScripts_functionMoneyGrant : public dp88_BuildingEffectScript
+{
+	void Created ( GameObject* obj );
+	void OnBuildingCaptured ( GameObject* obj, int team );
+};
+
 // Spawn team zone - spawns a script zone depending on which team currently owns
 // the building
 class dp88_buildingScripts_functionSpawnTeamZone : public dp88_BuildingEffectScript
diff -uwr sourceold/scripts/dp88_customAI.cpp source/scripts/dp88_customAI.cpp
--- sourceold/scripts/dp88_customAI.cpp	2011-10-22 21:53:45.773437500 +0800
+++ source/scripts/dp88_customAI.cpp	2012-05-23 10:21:56.112304600 +0800
@@ -9,11 +9,13 @@
 	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
 	Only the source code to the module(s) containing the licenced code has to be released.
 */
+
 // Include files
 #include "general.h"
 #include "scripts.h"
 #include "engine.h"
 #include "dp88_customAI.h"
+#include "dp88_custom_timer_defines.h"
 #include "VehicleGameObj.h"
 
 /*------------------------
@@ -113,7 +115,7 @@
 		return 0.0;
 	}
 
-	if ( Is_Vehicle(target) && !IsVehicleAIEnabled(target->As_VehicleGameObj()) && IsVehicleEmpty(target->As_VehicleGameObj()) )
+	if ( target->As_VehicleGameObj() && !IsVehicleAIEnabled(target->As_VehicleGameObj()) && IsVehicleEmpty(target->As_VehicleGameObj()) )
 	{
 		if ( debug ) fprintf ( debugFile, "Target %d is an empty, non-AI vehicle, ignoring\n", Commands->Get_ID(target));
 		return 0.0;
@@ -123,15 +125,15 @@
 
 
 	// Assign base priority
-	if ( Is_Soldier ( target ) && !Get_Fly_Mode(target) )
+	if ( target->As_SoldierGameObj() && !Get_Fly_Mode(target) )
 		priority = (float)priority_infantry;
-	else if ( Is_VTOLVehicle ( target ) || (Is_Soldier(target) && Get_Fly_Mode(target)) )
+	else if ( Get_Vehicle_Mode ( target ) == VEHICLE_TYPE_FLYING || (target->As_SoldierGameObj() && Get_Fly_Mode(target)) )
 		priority = (float)priority_VTOL;
-	else if ( Is_Vehicle ( target ) && Is_Script_Attached ( target, "dp88_AI_heavyVehicleMarker" ) )
+	else if ( target->As_VehicleGameObj() && Is_Script_Attached ( target, "dp88_AI_heavyVehicleMarker" ) )
 		priority = (float)priority_heavyVehicle;
-	else if ( Is_Vehicle ( target ) )
+	else if ( target->As_VehicleGameObj() )
 		priority = (float)priority_lightVehicle;
-	else if ( Is_Building ( target ) )
+	else if ( target->As_BuildingGameObj() )
 		priority = (float)priority_building;
 
 	// Return if our base priority for this target type is 0
@@ -146,7 +148,7 @@
 
 	// Apply target value modifier (add X priority for every 10 credits the target
 	// cost to purchase - not applicable to buildings)
-	if ( !Is_Building( target ) )
+	if ( !target->As_BuildingGameObj() )
 	{
 		int cost = Get_Team_Cost( Commands->Get_Preset_Name ( target ), Commands->Get_Player_Type ( target ) );
 		priority += ((float)cost/10.0f) * modifier_target_value;
@@ -195,13 +197,13 @@
 
 bool dp88_customAI::getPrimary ( GameObject *target )
 {
-	if ( Is_Soldier ( target ) )
+	if ( target->As_SoldierGameObj() )
 		return primary_infantry;
-	else if ( Is_VTOLVehicle ( target ) )
+	else if ( Get_Vehicle_Mode ( target ) == VEHICLE_TYPE_FLYING )
 		return primary_VTOL;
-	else if ( Is_Vehicle ( target ) )
+	else if ( target->As_VehicleGameObj() )
 		return (Is_Script_Attached(target,"dp88_AI_heavyVehicleMarker")) ? primary_heavyVehicle : primary_lightVehicle;
-	else if ( Is_Building ( target ) )
+	else if ( target->As_BuildingGameObj() )
 		return primary_building;
 	return true;
 }
@@ -486,7 +488,7 @@
 		targetPriority = enemyPriority;
 		primary_target = attackPrimary;
 
-		if ( splashInfantry && Is_Soldier(enemy) )
+		if ( splashInfantry && enemy->As_SoldierGameObj() )
 		{
 			if ( debug ) fprintf ( debugFile, "Using splash damage against this target\n" );
 			attackLocation(obj,Commands->Get_Position(enemy),primary_target);
@@ -505,13 +507,12 @@
 		if ( targetID != 0 )
 		{
 			GameObject *target = Commands->Find_Object ( targetID );
-
-			if ( !checkPowerState(obj)
+			if (!target || !checkPowerState(obj)
 				|| ( Commands->Get_Health ( target ) + Commands->Get_Shield_Strength ( target ) <= 0 )
 				|| !checkTeam ( obj, target )
 				|| !checkRange ( obj, target, primary_target )
 				|| (int)time(NULL) - targetLastSeen > 3
-				|| ( Is_Vehicle(target) && !IsVehicleAIEnabled(target->As_VehicleGameObj()) && IsVehicleEmpty(target->As_VehicleGameObj()) ) )
+				|| ( target->As_VehicleGameObj() && !IsVehicleAIEnabled(target->As_VehicleGameObj()) && IsVehicleEmpty(target->As_VehicleGameObj()) ))
 			{
 				if ( debug ) fprintf ( debugFile, "Target %d no longer valid, ceasing attack.\n", targetID);
 				targetID = 0;
@@ -522,7 +523,7 @@
 
 			// Otherwise we are OK to continue attacking... if this is an infantry unit
 			// and splash targetting is enabled then update targetting position
-			else if ( splashInfantry && Is_Soldier(target) )
+			else if ( splashInfantry && target->As_SoldierGameObj() )
 				attackLocation ( obj, Commands->Get_Position(target), primary_target );
 		}
 
@@ -636,12 +637,436 @@
 
 
 
-/*------------------------
-Script Registrants
---------------------------*/
+// -------------------------------------------------------------------------------------------------
+//  Popup Turret AI
+// -------------------------------------------------------------------------------------------------
 
-ScriptRegistrant<dp88_tankAI_Offensive> dp88_tankAI_Offensive_Registrant("dp88_tankAI_Offensive","Priority_Infantry=1:int,Weapon_Infantry=1:int,priority_lightVehicle=5:int,priority_heavyVehicle=7:int,Weapon_Vehicle=1:int,Priority_VTOL=5:int,Weapon_VTOL=1:int,Priority_Building=12:int,Weapon_Building=1:int,Max_Attack_Range=150:int,Min_Attack_Range=0:int,Preferred_Attack_Range=60:int,Max_Attack_Range_Secondary=150:int,Min_Attack_Range_Secondary=0:int,Preferred_Attack_Range_Secondary=60:int");
-ScriptRegistrant<dp88_AI_Turret> dp88_AI_Turret_Registrant("dp88_AI_Turret","Priority_Infantry=1.0:float,Weapon_Infantry=1:int,Splash_Infantry=0:int,Priority_Light_Vehicle=5.0:float,Weapon_Light_Vehicle=5:int,Priority_Heavy_Vehicle=7.0:float,Weapon_Heavy_Vehicle=1:int,Priority_VTOL=5.0:float,Weapon_VTOL=1:int,Min_Attack_Range=0:int,Max_Attack_Range=150:int,Min_Attack_Range_Secondary=0:int,Max_Attack_Range_Secondary=150:int,Modifier_Distance=0.25:float,Modifier_Target_Damage=0.1:float,Modifier_Target_Value=0.05:float,Requires_Power=0:int,Debug=0:int");
+void dp88_AI_PopupTurret::Created ( GameObject* pSelf )
+{
+  m_deploymentState = STATE_UNDEPLOYED;
+  m_spotterId = 0;
+
+  // Create our spotter turret
+  GameObject* pSpotter = Commands->Create_Object ( Get_Parameter("Spotter_Preset"), Commands->Get_Position(pSelf) );
+  if ( pSpotter )
+  {
+    m_spotterId = Commands->Get_ID(pSpotter);
+
+    // Set the spotter turret to match our configuration, but invisible
+    Commands->Set_Model ( pSpotter, Get_Model(pSelf) );
+    Commands->Set_Is_Rendered ( pSpotter, false );
+	Commands->Enable_Enemy_Seen ( pSpotter, true );
+    Commands->Disable_All_Collisions ( pSpotter );
+    Commands->Innate_Enable ( pSpotter );
+    Set_Skin ( pSpotter, "Blamo" );
+
+    // Attach the spotter script
+    char scriptParams[20];
+    sprintf_s ( scriptParams, sizeof(scriptParams), "%d", Commands->Get_ID(pSelf) );
+    Commands->Attach_Script ( pSpotter, "dp88_AI_PopupTurret_Spotter", scriptParams );
+
+    // 'Deploy' the spotter turret so it can see what we would be able to see whilst deployed
+    Commands->Set_Animation_Frame ( pSpotter, Get_Parameter("Deploy_Animation"), Get_Int_Parameter("Deploy_Animation_Frames") );
+
+	// Make sure the turret itself starts popped down
+	Commands->Set_Animation_Frame ( pSelf, Get_Parameter("Deploy_Animation"), 0 );
+  }
+
+  dp88_AI_Turret::Created(pSelf);
+}
+
+// -------------------------------------------------------------------------------------------------
+
+void dp88_AI_PopupTurret::Timer_Expired ( GameObject* pSelf, int number )
+{
+  // Piggy-back the undeploy timer logic on the existing target check timer since its always running
+  if ( number == TIMER_CHECK_TARGET && m_deploymentState == STATE_DEPLOYED )
+  {
+    // If we have no target and have reached the undeploy timeout then trigger undeployment
+    if ( targetID == 0 && time(NULL) > m_undeployTime )
+      Undeploy(pSelf);
+    
+    // Else, if we have an active target, update the undeployment timeout time
+    else if ( targetID != 0 )
+      m_undeployTime = time(NULL)+Get_Int_Parameter("Deploy_Timeout");
+  }
+
+  dp88_AI_Turret::Timer_Expired(pSelf, number);
+}
+
+// -------------------------------------------------------------------------------------------------
+
+void dp88_AI_PopupTurret::Custom ( GameObject* pSelf, int type, int param, GameObject* pSender )
+{
+  if ( m_spotterId == Commands->Get_ID(pSender) )
+  {
+    // Spotter only ever sends us one type of message... enemy spotted! Note that we don't simply
+    // deploy here because it might be a target we can't / shouldn't attack, let Enemy_Seen decide
+    // if we actually need to do anything
+    GameObject* pEnemy = Commands->Find_Object(param);
+    if ( pEnemy )
+      Enemy_Seen(pSelf, pEnemy);
+  }
+  else
+    dp88_AI_Turret::Custom(pSelf, type, param, pSender);
+}
+
+// -------------------------------------------------------------------------------------------------
+
+void dp88_AI_PopupTurret::Animation_Complete ( GameObject* pSelf, const char* animation_name )
+{
+  if ( m_deploymentState == STATE_DEPLOYING )
+  {
+    m_deploymentState = STATE_DEPLOYED;
+    m_undeployTime = time(NULL)+Get_Int_Parameter("Deploy_Timeout");
+
+    // Reset targetting parameters, otherwise the next Enemy_Seen call will think we are already attacking
+    // an enemy and not trigger the appropriate actions we are depending upon
+    targetID = 0;
+  }
+  else if ( m_deploymentState == STATE_UNDEPLOYING )
+    m_deploymentState = STATE_UNDEPLOYED;
+
+  dp88_AI_Turret::Animation_Complete(pSelf, animation_name);
+}
+
+// -------------------------------------------------------------------------------------------------
+
+void dp88_AI_PopupTurret::Destroyed ( GameObject* pSelf )
+{
+  if ( GameObject* pSpotter = Commands->Find_Object(m_spotterId) )
+    Commands->Destroy_Object(pSpotter);
+}
+
+// -------------------------------------------------------------------------------------------------
+
+void dp88_AI_PopupTurret::attackTarget ( GameObject* pSelf, GameObject* pTarget, bool primary )
+{
+  if ( m_deploymentState == STATE_DEPLOYED )
+    dp88_AI_Turret::attackTarget(pSelf, pTarget, primary);
+  else
+    Deploy(pSelf); // No need to remember what we are deploying to shoot, enemy seen will be re-triggered
+}
+
+// -------------------------------------------------------------------------------------------------
+
+void dp88_AI_PopupTurret::attackLocation ( GameObject* pSelf, Vector3 location, bool primary )
+{
+  if ( m_deploymentState == STATE_DEPLOYED )
+    dp88_AI_Turret::attackLocation(pSelf, location, primary);
+  else
+    Deploy(pSelf); // No need to remember what we are deploying to shoot, enemy seen will be re-triggered
+}
+
+// -------------------------------------------------------------------------------------------------
+
+void dp88_AI_PopupTurret::Deploy ( GameObject* pSelf )
+{
+  if ( m_deploymentState == STATE_UNDEPLOYED || m_deploymentState == STATE_UNDEPLOYING )
+  {
+    m_deploymentState = STATE_DEPLOYING;
+
+    Commands->Set_Animation(pSelf,Get_Parameter("Deploy_Animation"),false,0,Get_Animation_Frame(pSelf),(float)Get_Int_Parameter("Deploy_Animation_Frames"),false);
+
+    if (_stricmp(Get_Parameter("Deploy_Sound"),"0"))
+      Commands->Create_Sound(Get_Parameter("Deploy_Sound"),Commands->Get_Position(pSelf),pSelf);
+  }
+}
+
+// -------------------------------------------------------------------------------------------------
+
+void dp88_AI_PopupTurret::Undeploy ( GameObject* pSelf )
+{
+  if ( m_deploymentState == STATE_DEPLOYED )
+  {
+    m_deploymentState = STATE_UNDEPLOYING;
+
+    Commands->Set_Animation(pSelf,Get_Parameter("Deploy_Animation"),false,0,(float)Get_Int_Parameter("Deploy_Animation_Frames"),0, false);
+
+    if (_stricmp(Get_Parameter("Deploy_Sound"),"0"))
+      Commands->Create_Sound(Get_Parameter("Deploy_Sound"),Commands->Get_Position(pSelf),pSelf);
+  }
+}
+
+
+
+
+
+
+
+// ------------------------------------------------------------------------------------------------
+//  Popup Turret Spotter
+// ------------------------------------------------------------------------------------------------
+
+void dp88_AI_PopupTurret_Spotter::Enemy_Seen ( GameObject* pSelf, GameObject* pEnemy )
+{
+  if ( GameObject* pTurret = Commands->Find_Object(Get_Int_Parameter("tId")) )
+    Commands->Send_Custom_Event ( pSelf, pTurret, CUSTOM_TURRETAI_ENEMYSEEN, Commands->Get_ID(pEnemy), 0.0f );
+}
+
+
+
+
+
+
+
+// -------------------------------------------------------------------------------------------------
+//  Charged Turret AI
+// -------------------------------------------------------------------------------------------------
+
+void dp88_AI_ChargedTurret::Created ( GameObject* pSelf )
+{
+  m_bIsCharging = false;
+  m_bIsDischarging = false;
+  m_chargeAnimObjId = NULL;
+
+  // If a seperate charge animation model has been specified then go ahead and spawn it
+  if ( strlen ( Get_Parameter("Animation_Model") ) > 0 )
+  {
+    GameObject* pChargeAnimObj = Commands->Create_Object ( "Invisible_Object", Commands->Get_Position(pSelf) );
+    if ( pChargeAnimObj )
+    {
+      m_chargeAnimObjId = Commands->Get_ID(pChargeAnimObj);
+      Commands->Set_Model ( pChargeAnimObj, Get_Parameter("Animation_Model") );
+      Commands->Attach_To_Object_Bone ( pChargeAnimObj, pSelf, Get_Parameter("Animation_Model_Bone") );
+
+      // Create the looped animation controller on the charge animation object
+      m_pLoopedAnimCtrl = new LoopedAnimationController ( pChargeAnimObj );
+
+      // Attach companion script so we get notified about animation complete events - we need to know
+      // about these so we know when the charged animation is complete.
+      //
+      // \todo Could this be done by simply attaching this script as a listener on the charged
+      //       animation object directly and checking the GameObject pointers we get on each
+      //       event to check which object they came from? Not sure which is cleaner...
+      char scriptParams[20];
+      sprintf_s ( scriptParams, sizeof(scriptParams), "%d", Commands->Get_ID(pSelf) );
+      Commands->Attach_Script ( pChargeAnimObj, "dp88_AI_ChargedTurret_Animation", scriptParams );
+    }
+  }
+
+  // If we don't have a charge animation object create the looped animation controller on ourselves
+  if ( m_chargeAnimObjId == NULL )
+    m_pLoopedAnimCtrl = new LoopedAnimationController ( pSelf );
+
+  m_bPowerState = checkPowerState(pSelf);
+  ApplyIdleAnimation(pSelf);
+
+  dp88_AI_Turret::Created(pSelf);
+}
+
+// -------------------------------------------------------------------------------------------------
+
+void dp88_AI_ChargedTurret::Timer_Expired ( GameObject* pSelf, int number )
+{
+  // Piggy-back the base power state checks on the existing target check timer since its always
+  // running anyway. If the base power state changes we need to update the idle animation (and
+  // abort any charge up in progress)
+  if ( number == TIMER_CHECK_TARGET && m_bPowerState != checkPowerState(pSelf) )
+  {
+    m_bPowerState = !m_bPowerState;
+
+    // Charging state must always become false now - either we were unpowered to begin with or
+    // we were powered and have now gone offline. Either way, we can't possibly be charging now.
+    m_bIsCharging = false;
+
+    // If we were discharging our weapon we need to stop now and trigger a reload so we don't
+    // fire a partial charge next time around
+    if ( m_bIsDischarging )
+    {
+      m_bIsDischarging = false;
+      stopAttacking(pSelf);
+      Set_Current_Bullets(pSelf, 0);
+    }
+
+    // Apply the appropriate idle animation
+    ApplyIdleAnimation(pSelf);
+  }
+
+
+  // We might as well piggy back the discharged checks on the same timer too whilst we are at it...
+  if ( number == TIMER_CHECK_TARGET && m_bIsDischarging )
+  {
+    // Have we unloaded our entire clip? If so then we can start charging for the next attack
+    if ( Get_Current_Bullets(pSelf) == 0 )
+    {
+      m_bIsDischarging = false;
+      stopAttacking(pSelf);   // Don't want to fire again before we are ready!
+      if ( targetID != NULL )
+        StartCharging(pSelf);
+      else
+        ApplyIdleAnimation(pSelf);
+    }
+
+    // Has our target already died or ran like a coward before we could empty our clip? If so then
+    // reset and trigger a reload (so we don't have a partial charge next time round)
+    else if ( targetID == NULL )
+    {
+      m_bIsDischarging = false;
+      Set_Current_Bullets(pSelf, 0);
+      ApplyIdleAnimation(pSelf);
+    }
+  }
+
+  dp88_AI_Turret::Timer_Expired(pSelf, number);
+}
+
+// -------------------------------------------------------------------------------------------------
+
+void dp88_AI_ChargedTurret::Animation_Complete ( GameObject* pSelf, const char* animation_name )
+{
+  if (!_stricmp(animation_name,Get_Parameter("Animation"))) //make sure we are running the right animation
+  {
+    // Were we charging up? If so we are now fully charged and can start shooting stuff, if we still
+    // have a valid target...
+    if ( m_bIsCharging )
+    {
+      m_bIsCharging = false;
+      m_bIsDischarging = true;
+  
+      // Got an enemy? Also double check power state whilst we are here, just to be sure
+      if ( targetID != NULL && checkPowerState(pSelf) )
+      {
+        if ( GameObject* pTarget = Commands->Find_Object(targetID) )
+        {
+  
+          // Call into the base class and let it do it's thing
+          if ( splashInfantry && pTarget->As_SoldierGameObj() )
+            dp88_AI_Turret::attackLocation(pSelf, Commands->Get_Position(pTarget), primary_target);
+          else
+            dp88_AI_Turret::attackTarget(pSelf, pTarget, primary_target);
+        }
+      }
+    }
+  }
+
+  dp88_AI_Turret::Animation_Complete(pSelf, animation_name);
+}
+
+// -------------------------------------------------------------------------------------------------
+
+void dp88_AI_ChargedTurret::Destroyed ( GameObject* pSelf )
+{
+  if (m_pLoopedAnimCtrl)
+  {
+	delete m_pLoopedAnimCtrl;
+  }
+  
+  if ( m_chargeAnimObjId )
+  {
+    if ( GameObject* pChargeAnimObj = Commands->Find_Object(m_chargeAnimObjId) )
+      Commands->Destroy_Object(pChargeAnimObj);
+  }
+}
+
+// -------------------------------------------------------------------------------------------------
+
+void dp88_AI_ChargedTurret::attackTarget ( GameObject* pSelf, GameObject* pTarget, bool primary )
+{
+  // Changing targets in the middle of discharging? Sure, why not...
+  if ( m_bIsDischarging )
+    dp88_AI_Turret::attackTarget ( pSelf, pTarget, primary );
+
+  // Otherwise call StartCharging and let it determine what to do...
+  StartCharging(pSelf);
+}
+
+// -------------------------------------------------------------------------------------------------
+
+void dp88_AI_ChargedTurret::attackLocation ( GameObject* pSelf, Vector3 location, bool primary )
+{
+  // Changing targets in the middle of discharging? Sure, why not...
+  if ( m_bIsDischarging )
+    dp88_AI_Turret::attackLocation ( pSelf, location, primary );
+
+  // Otherwise call StartCharging and let it determine what to do...
+  StartCharging(pSelf);
+}
+
+// -------------------------------------------------------------------------------------------------
+
+void dp88_AI_ChargedTurret::StartCharging ( GameObject* pSelf )
+{
+  // If we are not charging, not discharging, powered and have a target then we can start a new
+  // charging cycle
+  if ( !m_bIsCharging && !m_bIsDischarging && checkPowerState(pSelf) && targetID != NULL )
+  {
+    m_bIsCharging = true;
+
+    // Only play a single iteration of the charge up animation - if we need to keep attacking after
+    // the shot is fired this will get called again
+    m_pLoopedAnimCtrl->PlayAnimation ( Get_Parameter("Animation"), Get_Int_Parameter("Animation_Charge_Start_Frame"), Get_Int_Parameter("Animation_Charge_End_Frame"), 1 );
+
+    if (_stricmp(Get_Parameter("Charge_Sound"),"0"))
+      Commands->Create_Sound(Get_Parameter("Charge_Sound"),Commands->Get_Position(pSelf),pSelf);
+
+    // Nothing to do but wait for the charging to complete... hum de dum...
+  }
+}
+
+// -------------------------------------------------------------------------------------------------
+
+GameObject* dp88_AI_ChargedTurret::GetAnimationObject ( GameObject* pSelf )
+{
+  if ( m_chargeAnimObjId != NULL )
+    return Commands->Find_Object(m_chargeAnimObjId);
+  return pSelf;
+}
+
+// -------------------------------------------------------------------------------------------------
+
+void dp88_AI_ChargedTurret::ApplyIdleAnimation ( GameObject* pSelf )
+{
+  // Apply the correct animation frames for the uncharged state dependant upon base power conditions,
+  // which should already have been updated before calling this function
+  if ( m_bPowerState )
+    m_pLoopedAnimCtrl->PlayAnimation(Get_Parameter("Animation"),Get_Int_Parameter("Animation_Idle_Start_Frame"),Get_Int_Parameter("Animation_Idle_End_Frame"));
+  else
+    m_pLoopedAnimCtrl->PlayAnimation(Get_Parameter("Animation"),Get_Int_Parameter("Animation_Unpowered_Start_Frame"),Get_Int_Parameter("Animation_Unpowered_End_Frame"));
+}
+
+// -------------------------------------------------------------------------------------------------
+
+void dp88_AI_ChargedTurret::Custom ( GameObject* pSelf, int type, int param, GameObject* pSender )
+{
+  if ( pSelf != pSender && GetAnimationObject(pSelf) == pSender )
+    Animation_Complete(pSelf, Get_Parameter("Animation"));
+}
+
+
+
+
+
+
+
+
+
+// -------------------------------------------------------------------------------------------------
+//  Charged Turret AI - Animation Complete Notifier
+// -------------------------------------------------------------------------------------------------
+
+void dp88_AI_ChargedTurret_Animation::Animation_Complete ( GameObject* pSelf, const char* animation_name )
+{
+  if ( GameObject* pTurret = Commands->Find_Object(Get_Int_Parameter("tId")) )
+    Commands->Send_Custom_Event ( pSelf, pTurret, CUSTOM_TURRETAI_ANIMATIONCOMPLETE, 0, 0.0f );
+}
+
+
+
+
+
+
+
+// -------------------------------------------------------------------------------------------------
+//  Script Registrants
+// -------------------------------------------------------------------------------------------------
 
 // Heavy vehicle marker (dummy script)
 ScriptRegistrant<dp88_AI_heavyVehicleMarker> dp88_AI_heavyVehicleMarker_Registrant("dp88_AI_heavyVehicleMarker","");
\ No newline at end of file
+
+ScriptRegistrant<dp88_tankAI_Offensive> dp88_tankAI_Offensive_Registrant("dp88_tankAI_Offensive","Priority_Infantry=1:int,Weapon_Infantry=1:int,priority_lightVehicle=5:int,priority_heavyVehicle=7:int,Weapon_Vehicle=1:int,Priority_VTOL=5:int,Weapon_VTOL=1:int,Priority_Building=12:int,Weapon_Building=1:int,Max_Attack_Range=150:int,Min_Attack_Range=0:int,Preferred_Attack_Range=60:int,Max_Attack_Range_Secondary=150:int,Min_Attack_Range_Secondary=0:int,Preferred_Attack_Range_Secondary=60:int");
+ScriptRegistrant<dp88_AI_Turret> dp88_AI_Turret_Registrant("dp88_AI_Turret","Priority_Infantry=1.0:float,Weapon_Infantry=1:int,Splash_Infantry=0:int,Priority_Light_Vehicle=5.0:float,Weapon_Light_Vehicle=5:int,Priority_Heavy_Vehicle=7.0:float,Weapon_Heavy_Vehicle=1:int,Priority_VTOL=5.0:float,Weapon_VTOL=1:int,Min_Attack_Range=0:int,Max_Attack_Range=150:int,Min_Attack_Range_Secondary=0:int,Max_Attack_Range_Secondary=150:int,Modifier_Distance=0.25:float,Modifier_Target_Damage=0.1:float,Modifier_Target_Value=0.05:float,Requires_Power=0:int,Debug=0:int");
+ScriptRegistrant<dp88_AI_PopupTurret> dp88_AI_PopupTurret_Registrant("dp88_AI_PopupTurret","Priority_Infantry=1.0:float,Weapon_Infantry=1:int,Splash_Infantry=0:int,Priority_Light_Vehicle=5.0:float,Weapon_Light_Vehicle=5:int,Priority_Heavy_Vehicle=7.0:float,Weapon_Heavy_Vehicle=1:int,Priority_VTOL=5.0:float,Weapon_VTOL=1:int,Min_Attack_Range=0:int,Max_Attack_Range=150:int,Min_Attack_Range_Secondary=0:int,Max_Attack_Range_Secondary=150:int,Deploy_Animation:string,Deploy_Animation_Frames:int,Deploy_Sound:string,Deploy_Timeout:int,Spotter_Preset:string,Modifier_Distance=0.25:float,Modifier_Target_Damage=0.1:float,Modifier_Target_Value=0.05:float,Requires_Power=0:int,Debug=0:int");
+ScriptRegistrant<dp88_AI_PopupTurret_Spotter> dp88_AI_PopupTurret_Spotter_Registrant("dp88_AI_PopupTurret_Spotter","tId:int");
+ScriptRegistrant<dp88_AI_ChargedTurret> dp88_AI_ChargedTurret_Registrant("dp88_AI_ChargedTurret","Priority_Infantry=1.0:float,Weapon_Infantry=1:int,Splash_Infantry=0:int,Priority_Light_Vehicle=5.0:float,Weapon_Light_Vehicle=5:int,Priority_Heavy_Vehicle=7.0:float,Weapon_Heavy_Vehicle=1:int,Priority_VTOL=5.0:float,Weapon_VTOL=1:int,Min_Attack_Range=0:int,Max_Attack_Range=150:int,Min_Attack_Range_Secondary=0:int,Max_Attack_Range_Secondary=150:int,Animation_Model:string,Animation_Model_Bone:string,Animation:string,Animation_Idle_Start_Frame:int,Animation_Idle_End_Frame:int,Animation_Unpowered_Start_Frame:int,Animation_Unpowered_End_Frame:int,Animation_Charge_Start_Frame:int,Animation_Charge_End_Frame:int,Charge_Sound:string,Modifier_Distance=0.25:float,Modifier_Target_Damage=0.1:float,Modifier_Target_Value=0.05:float,Requires_Power=0:int,Debug=0:int");
+ScriptRegistrant<dp88_AI_ChargedTurret_Animation> dp88_AI_ChargedTurret_Animation_Registrant("dp88_AI_ChargedTurret_Animation","tId:int");
